<?php
namespace Planejamento\Entities;

use Geral\Util\Ambiente;
use Geral\Util\DateUtil;

class Compcarddel extends Base\Compcarddel
{
    public static function insere(
        $nrorg, $cdfilial, $cdservfili, $dtpratexcl, $nrseqpratexcl, $idlocalexcl,
        $cdfilauxprat, $cdprato
    )
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();

            $compcarddel = new Compcarddel();
            $compcarddel->setCdfilial($cdfilial);
            $compcarddel->setCdservfili($cdservfili);
            $compcarddel->setDtpratexcl($dtpratexcl);
            $compcarddel->setNrseqpratexcl($nrseqpratexcl);
            $compcarddel->setIdlocalexcl($idlocalexcl);
            $compcarddel->setCdfilauxprat($cdfilauxprat);
            $compcarddel->setCdprato($cdprato);
            $compcarddel->setNrorg($nrorg);
            $compcarddel->setNrorginclusao($nrorg);
            $compcarddel->setNrorgultatu($nrorg);
            $compcarddel->setDtinclusao(DateUtil::getDataAtual());
            $compcarddel->setDtultatu(DateUtil::getDataAtual());
            $compcarddel->setCdoperinclusao(Ambiente::getCdOperador());
            $compcarddel->setCdoperultatu(Ambiente::getCdOperador());
            $compcarddel->setIdativo('S');
            $compcarddel->persist();

            $connection->flush();
            $connection->commit();

            return true;
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public static function atualiza(
        $nrorg, $cdfilial, $cdservfili, $dtpratexcl, $nrseqpratexcl, $idlocalexcl
    )
    {
        try {
            $compcarddel = Compcarddel::getObjectByWhere(
                'NRORG = ? CDFILIAL = ? AND CDSERVFILI = ? AND DTPRATEXCL = ? AND
                NRSEQPRATEXCL = ?',
                array(
                    $nrorg, $cdfilial, $cdservfili, $dtpratexcl, $nrseqpratexcl
                )
            );

            if ($compcarddel instanceof Compcarddel) {
                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $connection->beginTransaction();


                $compcarddel->setIdlocalexcl($idlocalexcl);
                $compcarddel->setNrorgultatu($nrorg);
                $compcarddel->setDtultatu(DateUtil::getDataAtual());
                $compcarddel->setCdoperultatu(Ambiente::getCdOperador());
                $compcarddel->persist();

                $connection->flush();
                $connection->commit();
            }

            return true;
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }
}